--============================================================================================
--##################################   Module Information   ##################################
--============================================================================================
--
-- Company: CERN 
--
-- Language: VHDL 2008
--
-- Description:
--
------------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


------------------------------------------------------------------------------------------------------
-- Entity
------------------------------------------------------------------------------------------------------
entity wb_32out_reg is
  generic(
    g_ADDR_WIDTH        : integer  := 5; 
    g_DATA_WIDTH        : integer  := 32;
    g_reg0_default      : std_logic_vector;
    g_reg0_autoclrmask  : std_logic_vector;
    g_reg1_default      : std_logic_vector;
    g_reg1_autoclrmask  : std_logic_vector;
    g_reg2_default      : std_logic_vector;
    g_reg2_autoclrmask  : std_logic_vector;
    g_reg3_default      : std_logic_vector;
    g_reg3_autoclrmask  : std_logic_vector;
    g_reg4_default      : std_logic_vector;
    g_reg4_autoclrmask  : std_logic_vector;
    g_reg5_default      : std_logic_vector;
    g_reg5_autoclrmask  : std_logic_vector;
    g_reg6_default      : std_logic_vector;
    g_reg6_autoclrmask  : std_logic_vector;
    g_reg7_default      : std_logic_vector;
    g_reg7_autoclrmask  : std_logic_vector;
    g_reg8_default      : std_logic_vector;
    g_reg8_autoclrmask  : std_logic_vector;
    g_reg9_default      : std_logic_vector; 
    g_reg9_autoclrmask  : std_logic_vector;    
    g_reg10_default     : std_logic_vector;
    g_reg10_autoclrmask : std_logic_vector;
    g_reg11_default     : std_logic_vector;
    g_reg11_autoclrmask : std_logic_vector;
    g_reg12_default     : std_logic_vector;
    g_reg12_autoclrmask : std_logic_vector;
    g_reg13_default     : std_logic_vector;
    g_reg13_autoclrmask : std_logic_vector;
    g_reg14_default     : std_logic_vector;
    g_reg14_autoclrmask : std_logic_vector;
    g_reg15_default     : std_logic_vector;
    g_reg15_autoclrmask : std_logic_vector;
    g_reg16_default     : std_logic_vector;
    g_reg16_autoclrmask : std_logic_vector;
    g_reg17_default     : std_logic_vector;
    g_reg17_autoclrmask : std_logic_vector;
    g_reg18_default     : std_logic_vector;
    g_reg18_autoclrmask : std_logic_vector;
    g_reg19_default     : std_logic_vector;
    g_reg19_autoclrmask : std_logic_vector;
    g_reg20_default     : std_logic_vector;
    g_reg20_autoclrmask : std_logic_vector;
    g_reg21_default     : std_logic_vector;
    g_reg21_autoclrmask : std_logic_vector;
    g_reg22_default     : std_logic_vector;
    g_reg22_autoclrmask : std_logic_vector;
    g_reg23_default     : std_logic_vector;
    g_reg23_autoclrmask : std_logic_vector;
    g_reg24_default     : std_logic_vector;
    g_reg24_autoclrmask : std_logic_vector;
    g_reg25_default     : std_logic_vector;
    g_reg25_autoclrmask : std_logic_vector;
    g_reg26_default     : std_logic_vector;
    g_reg26_autoclrmask : std_logic_vector;
    g_reg27_default     : std_logic_vector;
    g_reg27_autoclrmask : std_logic_vector;
    g_reg28_default     : std_logic_vector;
    g_reg28_autoclrmask : std_logic_vector;
    g_reg29_default     : std_logic_vector;
    g_reg29_autoclrmask : std_logic_vector;
    g_reg30_default     : std_logic_vector;
    g_reg30_autoclrmask : std_logic_vector;
    g_reg31_default     : std_logic_vector;
    g_reg31_autoclrmask : std_logic_vector
  );
  port (
    --CLK/RST
    rst_ir       : in    std_logic; 
    clk_ik       : in    std_logic; 
    cen_ie       : in    std_logic; 
    --Master WishBone
    Cyc_i        : in    std_logic; 
    Stb_i        : in    std_logic; 
    Adr_ib       : in    std_logic_vector(g_ADDR_WIDTH-1 downto 0); 
    Sel_ib       : in    std_logic_vector(g_DATA_WIDTH/8-1 downto 0); 
    We_i         : in    std_logic; 
    DatMoSi_ib   : in    std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    DatMiSo_oqb  : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    Ack_oq       : out   std_logic; 
    Stall_o      : out   std_logic; 
    --Update strobes
    reg_wr_ob32  : out   std_logic_vector(31 downto 0); 
    --Registers
    reg0_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg1_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg2_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg3_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg4_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg5_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg6_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg7_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg8_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg9_ob      : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg10_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg11_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg12_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg13_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg14_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg15_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg16_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg17_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg18_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg19_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg20_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg21_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg22_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg23_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg24_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg25_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg26_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg27_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg28_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg29_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg30_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0); 
    reg31_ob     : out   std_logic_vector(g_DATA_WIDTH-1 downto 0)
  );
end entity;




------------------------------------------------------------------------------------------------------
-- Architecture
------------------------------------------------------------------------------------------------------
architecture rtl of wb_32out_reg is

  --Registers
  signal reg0_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg1_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg2_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg3_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg4_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg5_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg6_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg7_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg8_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg9_b  : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg10_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg11_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg12_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg13_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg14_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg15_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg16_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg17_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg18_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg19_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg20_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg21_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg22_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg23_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg24_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg25_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg26_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg27_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg28_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg29_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg30_b : std_logic_vector(g_DATA_WIDTH-1 downto 0); 
  signal reg31_b : std_logic_vector(g_DATA_WIDTH-1 downto 0);
  
  --internal
  signal Ack_q : std_logic;

begin 
  
  -----------------------
  -- Address decoding
  -----------------------
  p_addr_decod: process(clk_ik, rst_ir)
  begin
    if rst_ir = '1' then
      Ack_q       <= '0';
      Stall_o     <= '0';
      reg_wr_ob32 <= (others=>'0');
      DatMiSo_oqb <= (others=>'0');
      --default ('to' direction to 'downto')
      reg0_b      <= g_reg0_default;
      reg1_b      <= g_reg1_default;
      reg2_b      <= g_reg2_default;
      reg3_b      <= g_reg3_default;
      reg4_b      <= g_reg4_default;
      reg5_b      <= g_reg5_default;
      reg6_b      <= g_reg6_default;
      reg7_b      <= g_reg7_default;
      reg8_b      <= g_reg8_default;
      reg9_b      <= g_reg9_default;
      reg10_b     <= g_reg10_default;
      reg11_b     <= g_reg11_default;
      reg12_b     <= g_reg12_default;
      reg13_b     <= g_reg13_default;
      reg14_b     <= g_reg14_default;
      reg15_b     <= g_reg15_default;
      reg16_b     <= g_reg16_default;
      reg17_b     <= g_reg17_default;
      reg18_b     <= g_reg18_default;
      reg19_b     <= g_reg19_default;
      reg20_b     <= g_reg20_default;
      reg21_b     <= g_reg21_default;
      reg22_b     <= g_reg22_default;
      reg23_b     <= g_reg23_default;
      reg24_b     <= g_reg24_default;
      reg25_b     <= g_reg25_default;
      reg26_b     <= g_reg26_default;
      reg27_b     <= g_reg27_default;
      reg28_b     <= g_reg28_default;
      reg29_b     <= g_reg29_default;
      reg30_b     <= g_reg30_default;
      reg31_b     <= g_reg31_default;

    elsif rising_edge(clk_ik) then
      if cen_ie = '1' then
        
        Ack_q       <= Stb_i AND Cyc_i AND not(Ack_q);
        Stall_o     <= '0';
        reg_wr_ob32 <=(others=>'0');

        --autoclear
        reg0_b  <= reg0_b  AND g_reg0_autoclrmask;
        reg1_b  <= reg1_b  AND g_reg1_autoclrmask;
        reg2_b  <= reg2_b  AND g_reg2_autoclrmask;
        reg3_b  <= reg3_b  AND g_reg3_autoclrmask;
        reg4_b  <= reg4_b  AND g_reg4_autoclrmask;
        reg5_b  <= reg5_b  AND g_reg5_autoclrmask;
        reg6_b  <= reg6_b  AND g_reg6_autoclrmask;
        reg7_b  <= reg7_b  AND g_reg7_autoclrmask;
        reg8_b  <= reg8_b  AND g_reg8_autoclrmask;
        reg9_b  <= reg9_b  AND g_reg9_autoclrmask;
        reg10_b <= reg10_b AND g_reg10_autoclrmask;
        reg11_b <= reg11_b AND g_reg11_autoclrmask;
        reg12_b <= reg12_b AND g_reg12_autoclrmask;
        reg13_b <= reg13_b AND g_reg13_autoclrmask;
        reg14_b <= reg14_b AND g_reg14_autoclrmask;
        reg15_b <= reg15_b AND g_reg15_autoclrmask;
        reg16_b <= reg16_b AND g_reg16_autoclrmask;
        reg17_b <= reg17_b AND g_reg17_autoclrmask;
        reg18_b <= reg18_b AND g_reg18_autoclrmask;
        reg19_b <= reg19_b AND g_reg19_autoclrmask;
        reg20_b <= reg20_b AND g_reg20_autoclrmask;
        reg21_b <= reg21_b AND g_reg21_autoclrmask;
        reg22_b <= reg22_b AND g_reg22_autoclrmask;
        reg23_b <= reg23_b AND g_reg23_autoclrmask;
        reg24_b <= reg24_b AND g_reg24_autoclrmask;
        reg25_b <= reg25_b AND g_reg25_autoclrmask;
        reg26_b <= reg26_b AND g_reg26_autoclrmask;
        reg27_b <= reg27_b AND g_reg27_autoclrmask;
        reg28_b <= reg28_b AND g_reg28_autoclrmask;
        reg29_b <= reg29_b AND g_reg29_autoclrmask;
        reg30_b <= reg30_b AND g_reg30_autoclrmask;
        reg31_b <= reg31_b AND g_reg31_autoclrmask;
        
             
        if Stb_i='1' AND Cyc_i='1' AND Ack_q='0' then
          -- write 
          if We_i='1' then 
               if unsigned(Adr_ib) = to_unsigned( 0,g_ADDR_WIDTH) then reg0_b  <= DatMoSi_ib; reg_wr_ob32(0) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 1,g_ADDR_WIDTH) then reg1_b  <= DatMoSi_ib; reg_wr_ob32(1) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 2,g_ADDR_WIDTH) then reg2_b  <= DatMoSi_ib; reg_wr_ob32(2) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 3,g_ADDR_WIDTH) then reg3_b  <= DatMoSi_ib; reg_wr_ob32(3) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 4,g_ADDR_WIDTH) then reg4_b  <= DatMoSi_ib; reg_wr_ob32(4) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 5,g_ADDR_WIDTH) then reg5_b  <= DatMoSi_ib; reg_wr_ob32(5) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 6,g_ADDR_WIDTH) then reg6_b  <= DatMoSi_ib; reg_wr_ob32(6) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 7,g_ADDR_WIDTH) then reg7_b  <= DatMoSi_ib; reg_wr_ob32(7) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 8,g_ADDR_WIDTH) then reg8_b  <= DatMoSi_ib; reg_wr_ob32(8) <='1';
            elsif unsigned(Adr_ib) = to_unsigned( 9,g_ADDR_WIDTH) then reg9_b  <= DatMoSi_ib; reg_wr_ob32(9) <='1';
            elsif unsigned(Adr_ib) = to_unsigned(10,g_ADDR_WIDTH) then reg10_b <= DatMoSi_ib; reg_wr_ob32(10)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(11,g_ADDR_WIDTH) then reg11_b <= DatMoSi_ib; reg_wr_ob32(11)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(12,g_ADDR_WIDTH) then reg12_b <= DatMoSi_ib; reg_wr_ob32(12)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(13,g_ADDR_WIDTH) then reg13_b <= DatMoSi_ib; reg_wr_ob32(13)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(14,g_ADDR_WIDTH) then reg14_b <= DatMoSi_ib; reg_wr_ob32(14)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(15,g_ADDR_WIDTH) then reg15_b <= DatMoSi_ib; reg_wr_ob32(15)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(16,g_ADDR_WIDTH) then reg16_b <= DatMoSi_ib; reg_wr_ob32(16)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(17,g_ADDR_WIDTH) then reg17_b <= DatMoSi_ib; reg_wr_ob32(17)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(18,g_ADDR_WIDTH) then reg18_b <= DatMoSi_ib; reg_wr_ob32(18)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(19,g_ADDR_WIDTH) then reg19_b <= DatMoSi_ib; reg_wr_ob32(19)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(20,g_ADDR_WIDTH) then reg20_b <= DatMoSi_ib; reg_wr_ob32(20)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(21,g_ADDR_WIDTH) then reg21_b <= DatMoSi_ib; reg_wr_ob32(21)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(22,g_ADDR_WIDTH) then reg22_b <= DatMoSi_ib; reg_wr_ob32(22)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(23,g_ADDR_WIDTH) then reg23_b <= DatMoSi_ib; reg_wr_ob32(23)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(24,g_ADDR_WIDTH) then reg24_b <= DatMoSi_ib; reg_wr_ob32(24)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(25,g_ADDR_WIDTH) then reg25_b <= DatMoSi_ib; reg_wr_ob32(25)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(26,g_ADDR_WIDTH) then reg26_b <= DatMoSi_ib; reg_wr_ob32(26)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(27,g_ADDR_WIDTH) then reg27_b <= DatMoSi_ib; reg_wr_ob32(27)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(28,g_ADDR_WIDTH) then reg28_b <= DatMoSi_ib; reg_wr_ob32(28)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(29,g_ADDR_WIDTH) then reg29_b <= DatMoSi_ib; reg_wr_ob32(29)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(30,g_ADDR_WIDTH) then reg30_b <= DatMoSi_ib; reg_wr_ob32(30)<='1';
            elsif unsigned(Adr_ib) = to_unsigned(31,g_ADDR_WIDTH) then reg31_b <= DatMoSi_ib; reg_wr_ob32(31)<='1';
            end if;
          --read
          else
               if unsigned(Adr_ib) = to_unsigned( 0,g_ADDR_WIDTH) then DatMiSo_oqb <= reg0_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 1,g_ADDR_WIDTH) then DatMiSo_oqb <= reg1_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 2,g_ADDR_WIDTH) then DatMiSo_oqb <= reg2_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 3,g_ADDR_WIDTH) then DatMiSo_oqb <= reg3_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 4,g_ADDR_WIDTH) then DatMiSo_oqb <= reg4_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 5,g_ADDR_WIDTH) then DatMiSo_oqb <= reg5_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 6,g_ADDR_WIDTH) then DatMiSo_oqb <= reg6_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 7,g_ADDR_WIDTH) then DatMiSo_oqb <= reg7_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 8,g_ADDR_WIDTH) then DatMiSo_oqb <= reg8_b ;
            elsif unsigned(Adr_ib) = to_unsigned( 9,g_ADDR_WIDTH) then DatMiSo_oqb <= reg9_b ;
            elsif unsigned(Adr_ib) = to_unsigned(10,g_ADDR_WIDTH) then DatMiSo_oqb <= reg10_b;
            elsif unsigned(Adr_ib) = to_unsigned(11,g_ADDR_WIDTH) then DatMiSo_oqb <= reg11_b;
            elsif unsigned(Adr_ib) = to_unsigned(12,g_ADDR_WIDTH) then DatMiSo_oqb <= reg12_b;
            elsif unsigned(Adr_ib) = to_unsigned(13,g_ADDR_WIDTH) then DatMiSo_oqb <= reg13_b;
            elsif unsigned(Adr_ib) = to_unsigned(14,g_ADDR_WIDTH) then DatMiSo_oqb <= reg14_b;
            elsif unsigned(Adr_ib) = to_unsigned(15,g_ADDR_WIDTH) then DatMiSo_oqb <= reg15_b;
            elsif unsigned(Adr_ib) = to_unsigned(16,g_ADDR_WIDTH) then DatMiSo_oqb <= reg16_b;
            elsif unsigned(Adr_ib) = to_unsigned(17,g_ADDR_WIDTH) then DatMiSo_oqb <= reg17_b;
            elsif unsigned(Adr_ib) = to_unsigned(18,g_ADDR_WIDTH) then DatMiSo_oqb <= reg18_b;
            elsif unsigned(Adr_ib) = to_unsigned(19,g_ADDR_WIDTH) then DatMiSo_oqb <= reg19_b;
            elsif unsigned(Adr_ib) = to_unsigned(20,g_ADDR_WIDTH) then DatMiSo_oqb <= reg20_b;
            elsif unsigned(Adr_ib) = to_unsigned(21,g_ADDR_WIDTH) then DatMiSo_oqb <= reg21_b;
            elsif unsigned(Adr_ib) = to_unsigned(22,g_ADDR_WIDTH) then DatMiSo_oqb <= reg22_b;
            elsif unsigned(Adr_ib) = to_unsigned(23,g_ADDR_WIDTH) then DatMiSo_oqb <= reg23_b;
            elsif unsigned(Adr_ib) = to_unsigned(24,g_ADDR_WIDTH) then DatMiSo_oqb <= reg24_b;
            elsif unsigned(Adr_ib) = to_unsigned(25,g_ADDR_WIDTH) then DatMiSo_oqb <= reg25_b;
            elsif unsigned(Adr_ib) = to_unsigned(26,g_ADDR_WIDTH) then DatMiSo_oqb <= reg26_b;
            elsif unsigned(Adr_ib) = to_unsigned(27,g_ADDR_WIDTH) then DatMiSo_oqb <= reg27_b;
            elsif unsigned(Adr_ib) = to_unsigned(28,g_ADDR_WIDTH) then DatMiSo_oqb <= reg28_b;
            elsif unsigned(Adr_ib) = to_unsigned(29,g_ADDR_WIDTH) then DatMiSo_oqb <= reg29_b;
            elsif unsigned(Adr_ib) = to_unsigned(30,g_ADDR_WIDTH) then DatMiSo_oqb <= reg30_b;
            elsif unsigned(Adr_ib) = to_unsigned(31,g_ADDR_WIDTH) then DatMiSo_oqb <= reg31_b;
            else                       DatMiSo_oqb <= x"ABADCAFE";
            end if;
          end if;
        end if;
      end if;
    end if;
  end process;
  
  --Ack output
  Ack_oq <= Ack_q AND Stb_i;
  
  --Reg output
  reg0_ob   <= reg0_b  ;
  reg1_ob   <= reg1_b  ;
  reg2_ob   <= reg2_b  ;
  reg3_ob   <= reg3_b  ;
  reg4_ob   <= reg4_b  ;
  reg5_ob   <= reg5_b  ;
  reg6_ob   <= reg6_b  ;
  reg7_ob   <= reg7_b  ;
  reg8_ob   <= reg8_b  ;
  reg9_ob   <= reg9_b  ;
  reg10_ob  <= reg10_b ;
  reg11_ob  <= reg11_b ;
  reg12_ob  <= reg12_b ;
  reg13_ob  <= reg13_b ;
  reg14_ob  <= reg14_b ;
  reg15_ob  <= reg15_b ;
  reg16_ob  <= reg16_b ;
  reg17_ob  <= reg17_b ;
  reg18_ob  <= reg18_b ;
  reg19_ob  <= reg19_b ;
  reg20_ob  <= reg20_b ;
  reg21_ob  <= reg21_b ;
  reg22_ob  <= reg22_b ;
  reg23_ob  <= reg23_b ;
  reg24_ob  <= reg24_b ;
  reg25_ob  <= reg25_b ;
  reg26_ob  <= reg26_b ;
  reg27_ob  <= reg27_b ;
  reg28_ob  <= reg28_b ;
  reg29_ob  <= reg29_b ;
  reg30_ob  <= reg30_b ;
  reg31_ob  <= reg31_b ;
  
end architecture;