#!/bin/sh

#Analysis (-a <[options...] file...>)
#sources
ghdl -a ../../rtl/timer.vhd 
ghdl -a ../../rtl/spi_phy_master.vhd
ghdl -a ../../rtl/i2c_master_wb.vhd
ghdl -a ../../rtl/pwm.vhd
ghdl -a ../../rtl/dac_ad5663_spi_protocol.vhd
ghdl -a ../../rtl/dac_ad5663armz.vhd
ghdl -a ../../rtl/adc_hv_ltc2484_spi_protocol.vhd
ghdl -a ../../rtl/adc_hv_ltc2484.vhd
ghdl -a ../../rtl/adc_4ch_ad7682_spi_protocol.vhd
ghdl -a ../../rtl/adc_4ch_ad7682.vhd
ghdl -a ../../rtl/fmc_hv_2ch_if.vhd
ghdl -a ../../rtl/wb_addr_decoder.vhd
ghdl -a ../../rtl/wb_32in_reg.vhd
ghdl -a ../../rtl/wb_32out_reg.vhd
ghdl -a ../../rtl/fmc_hv_2ch_regulator.vhd
ghdl -a ../../rtl/fmc_hv_2ch_wb.vhd
#TB 
ghdl -a ../eeprom_at24c32.vhd
ghdl -a ../dac_ad5663.vhd
ghdl -a ../adc_ad7682.vhd
ghdl -a ../adc_ltc2484.vhd
ghdl -a ../top_tb.vhd 
if [ $? != 0 ]; then
  echo "GHDL Analysis failed!!!"
  exit 1
fi

#Elaboration (-e <[options...] [library.]top_unit [arch]>)
ghdl -e top_tb
if [ $? != 0 ]; then
  echo "GHDL Elaboration failed!!!!"
  exit 1
fi

#Run Simulation (-r <[options...] [library.]top_unit [arch] [simulation_options...]>)
ghdl -r --ieee=synopsys top_tb --stop-time=200us --assert-level=error --ieee-asserts=disable-at-0 --vcd=top_tb.vcd 
if [ $? != 0 ]; then
  echo "GHDL Simulation failed!!!"
  exit 1
fi

#plot the waveform
gtkwave top_tb.vcd config.gtkw
if [ $? != 0 ]; then
  echo "GtkWave Waveform visualization failed!!!"
  exit 1
fi
